#!/bin/csh -f                 # can leave out if use: csh <this>
set k = 59                    # line to skip to, 1-based: this is line 2      
set u = `pwd`                 # save pwd/unpackdir
set z = .$$                   # get rand pid dotname
onintr c                      # setup cleanup goto
if (-e .zz_) exit             # if untar target exists, quit
touch .zz_ >& /dev/null       # see if can make a file
if (! -e .zz_) exit           # if not, quit
rm -f .zz_                    # rm testfile
if (-e $z.tgz) exit           # check, quit if tarfile preexists
if ($term != "xterm") then    # help1: hard to kill from Terminal
  echo "run from X11.app xterm, not Terminal"
  exit
endif
if ($#argv != 1 && $#argv != 2) then   # help2: print incl scripts
  echo "use: $0 <script> [usb]     (usb: Mac-only)"
  echo "start=fn-F1 reset=fn-F2 quit=Esc"
  echo scripts:
  foreach s (`sed -n '58p;58q' $0`)  # put scriptlist line between this,tarfile
    echo "  $s"
  end
  exit
endif
set s = $1                    # should be builtin (and allowed) script to run
if (-e $u/$s) then            # local version of script exists
  set s = $u/$s               # use local instead of unpacked default
  if (`cat $s | wc -l` == 0) rm -f $s" # rm empty loc (mmap scr > scr), bak2def
endif
tail -n +$k $0 > $z.tgz       # peel out tarfile
tar xfz $z.tgz >& /dev/null   # untar it, untars into testfile name
mv .zz_ $z                    # move it to the random name
rm -f $z.tgz                  # rm tarfile
cd $z                         # cd into untar'd
ln -s $u logs                 # link logs back to unpack dir
set path = ( . /usr/sbin /usr/X11R6/bin /usr/X11/bin $path )  # be sure to find
setenv PULSECNT -1            # default: wait F1
if (-e $s) then               # if the script exists
  if ($#argv == 2 && $2 == "usb") then # maybe get second arg
    if (`uname` == "Darwin") the       # Darwin only
      setenv PULSECNT 5                # default num2skip if usb (else no hang)
      loadUSB ./AccesLoader            # load firmware to USB box
      sleep 1                          # need this sleep else USB box not ready
    endif
  endif
  set y = 0                            # pick correct binary, suffix -> quiet
  if (`uname` == "Linux") set y = 1    # maybe Linux instead
  setenv MAPPER_DIR .                  # mapper now checks, not used
  setenv MAPPERPROG ./mapper${y}       # scripts use, need . even w/path .
  setenv __GL_SYNC_TO_VBLANK 1         # for nvidia cards
  csh $s >& /dev/null          # run script (either unpacked or local)
  cat $s                       # dump currently running script verbatim for mod
  sleep 2                      # mapper in bg, so don't delete dir before used
endif
c:                             # goto interrupt label
cd $u                          # back to unpackdir
rm -rf $z $z.tgz               # cleanup (tarfile too in case hang or kill)
exit                           # exit here while binary running
